<?php

namespace ileven_\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOrderDetail ArrayType
 * @package Ileven_
 * @subpackage Arrays
 * @version 0.1
 * @date 2019-01-13
 */
class Ileven_ArrayOfOrderDetail extends AbstractStructArrayBase
{
    /**
     * The OrderDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \ileven_\StructType\Ileven_OrderDetail[]
     */
    public $OrderDetail;
    /**
     * Constructor method for ArrayOfOrderDetail
     * @uses Ileven_ArrayOfOrderDetail::setOrderDetail()
     * @param \ileven_\StructType\Ileven_OrderDetail[] $orderDetail
     */
    public function __construct(array $orderDetail = array())
    {
        $this
            ->setOrderDetail($orderDetail);
    }
    /**
     * Get OrderDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ileven_\StructType\Ileven_OrderDetail[]|null
     */
    public function getOrderDetail()
    {
        return isset($this->OrderDetail) ? $this->OrderDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOrderDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrderDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrderDetailForArrayConstraintsFromSetOrderDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOrderDetailOrderDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfOrderDetailOrderDetailItem instanceof \ileven_\StructType\Ileven_OrderDetail) {
                $invalidValues[] = is_object($arrayOfOrderDetailOrderDetailItem) ? get_class($arrayOfOrderDetailOrderDetailItem) : sprintf('%s(%s)', gettype($arrayOfOrderDetailOrderDetailItem), var_export($arrayOfOrderDetailOrderDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OrderDetail property can only contain items of type \ileven_\StructType\Ileven_OrderDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OrderDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \ileven_\StructType\Ileven_OrderDetail[] $orderDetail
     * @return \ileven_\ArrayType\Ileven_ArrayOfOrderDetail
     */
    public function setOrderDetail(array $orderDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($orderDetailArrayErrorMessage = self::validateOrderDetailForArrayConstraintsFromSetOrderDetail($orderDetail))) {
            throw new \InvalidArgumentException($orderDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($orderDetail) || (is_array($orderDetail) && empty($orderDetail))) {
            unset($this->OrderDetail);
        } else {
            $this->OrderDetail = $orderDetail;
        }
        return $this;
    }
    /**
     * Add item to OrderDetail value
     * @throws \InvalidArgumentException
     * @param \ileven_\StructType\Ileven_OrderDetail $item
     * @return \ileven_\ArrayType\Ileven_ArrayOfOrderDetail
     */
    public function addToOrderDetail(\ileven_\StructType\Ileven_OrderDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \ileven_\StructType\Ileven_OrderDetail) {
            throw new \InvalidArgumentException(sprintf('The OrderDetail property can only contain items of type \ileven_\StructType\Ileven_OrderDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OrderDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \ileven_\StructType\Ileven_OrderDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \ileven_\StructType\Ileven_OrderDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \ileven_\StructType\Ileven_OrderDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \ileven_\StructType\Ileven_OrderDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \ileven_\StructType\Ileven_OrderDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OrderDetail
     */
    public function getAttributeName()
    {
        return 'OrderDetail';
    }
}
