<?php

namespace ileven_\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Create ServiceType
 * @package Ileven_
 * @subpackage Services
 * @version 0.1
 * @date 2019-01-13
 */
class Ileven_Create extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named CreateOrder
     * Meta information extracted from the WSDL
     * - documentation: Create New Order for channel
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \ileven_\StructType\Ileven_CreateOrder $parameters
     * @return \ileven_\StructType\Ileven_CreateOrderResponse|bool
     */
    public function CreateOrder(\ileven_\StructType\Ileven_CreateOrder $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->CreateOrder($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \ileven_\StructType\Ileven_CreateOrderResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
